diff --git a/pithos-macos/PithosSyncDaemon.m b/pithos-macos/PithosSyncDaemon.m
index 5366cd6..81efa3c 100644
--- a/pithos-macos/PithosSyncDaemon.m
+++ b/pithos-macos/PithosSyncDaemon.m
@@ -836,7 +920,8 @@
         objectRequest.didFinishSelector = @selector(performRequestFinishedDelegateInBackground:);
         objectRequest.didFailSelector = @selector(performRequestFailedDelegateInBackground:);
         PithosActivity *activity = [activityFacility startActivityWithType:PithosActivityCreateDirectory 
-                                                                   message:[NSString stringWithFormat:@"Sync: Creating directory '%@'", object.name]];
+                                                                   message:[NSString stringWithFormat:@"Sync: Creating directory '%@'", object.name] 
+                                                             pithosAccount:pithosAccount];
         dispatch_async(dispatch_get_main_queue(), ^{
             [activityFacility updateActivity:activity withMessage:activity.message];
         });
@@ -875,7 +960,8 @@
                 objectRequest.didFinishSelector = @selector(performRequestFinishedDelegateInBackground:);
                 objectRequest.didFailSelector = @selector(performRequestFailedDelegateInBackground:);
                 PithosActivity *activity = [activityFacility startActivityWithType:PithosActivityDelete 
-                                                                           message:[NSString stringWithFormat:@"Sync: Moving to trash '%@'", object.name]];
+                                                                           message:[NSString stringWithFormat:@"Sync: Moving to trash '%@'", object.name] 
+                                                                     pithosAccount:pithosAccount];
                 dispatch_async(dispatch_get_main_queue(), ^{
                     [activityFacility updateActivity:activity withMessage:activity.message];
                 });
@@ -892,19 +978,16 @@
                                           nil];
                 [networkQueue addOperation:[PithosUtilities prepareRequest:objectRequest priority:NSOperationQueuePriorityHigh]];
             } else {
-                syncIncomplete = YES;
-                [self decreaseSyncOperationCount];
+                [self syncOperationFinishedWithSuccess:NO];
             }
         } else {
-            syncIncomplete = YES;
-            [self decreaseSyncOperationCount];
+            [self syncOperationFinishedWithSuccess:NO];
         }
     } else {
         // Upload file to remote object
         if (!fileExists || isDirectory) {
             // Local file object deleted or changed to a directory in the meantime, mark the sync cycle as incomplete and skip
-            syncIncomplete = YES;
-            [self decreaseSyncOperationCount];
+            [self syncOperationFinishedWithSuccess:NO];
             [pool drain];
             return;
         }
@@ -932,7 +1015,8 @@
             PithosActivity *activity = [activityFacility startActivityWithType:PithosActivityUpload 
                                                                        message:[NSString stringWithFormat:@"Sync: Uploading '%@' (0%%)", object.name]
                                                                     totalBytes:[[objectRequest.userInfo objectForKey:@"bytes"] unsignedIntegerValue]
-                                                                  currentBytes:0];
+                                                                  currentBytes:0 
+                                                                 pithosAccount:pithosAccount];
             dispatch_async(dispatch_get_main_queue(), ^{
                 [activityFacility updateActivity:activity withMessage:activity.message];
             });
@@ -953,8 +1037,7 @@
               nil]];
             [networkQueue addOperation:[PithosUtilities prepareRequest:objectRequest priority:NSOperationQueuePriorityNormal]];
         } else {
-            syncIncomplete = YES;
-            [self decreaseSyncOperationCount];
+            [self syncOperationFinishedWithSuccess:NO];
         }
     }
     [pool drain];
@@ -964,21 +1047,59 @@
 #pragma mark ASIHTTPRequestDelegate
 
 - (void)performRequestFinishedDelegateInBackground:(ASIPithosRequest *)request {
-    dispatch_async(queue, ^{
-        [self performSelector:NSSelectorFromString([request.userInfo objectForKey:@"didFinishSelector"]) withObject:request];
-    });
+    // Add an operation to the callbackQueue with a completionBlock for the case of cancellation
+    NSInvocationOperation *operation = [[[NSInvocationOperation alloc] initWithTarget:self 
+                                                                             selector:NSSelectorFromString([request.userInfo objectForKey:@"didFinishSelector"]) 
+                                                                               object:request] autorelease];
+    operation.completionBlock = ^{
+        NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+        if ([[request.userInfo objectForKey:@"operation"] isCancelled]) {
+            dispatch_async(dispatch_get_main_queue(), ^{
+                [activityFacility endActivity:[request.userInfo objectForKey:@"activity"] 
+                                  withMessage:[request.userInfo objectForKey:@"stoppedActivityMessage"]];
+            });
+            [self syncOperationFinishedWithSuccess:NO];
+        }
+        [pool drain];
+    };
+    [(NSMutableDictionary *)request.userInfo setObject:operation forKey:@"operation"];
+    [callbackQueue addOperation:operation];
 }
 
 - (void)performRequestFailedDelegateInBackground:(ASIPithosRequest *)request {
-    dispatch_async(queue, ^{
-        [self performSelector:NSSelectorFromString([request.userInfo objectForKey:@"didFailSelector"]) withObject:request];
-    });
+    if (request.isCancelled) {
+        // Request has been cancelled 
+        // The callbackQueue might be suspended so we call directly the callback method, since it does minimal work anyway
+        [self performSelector:NSSelectorFromString([request.userInfo objectForKey:@"didFailSelector"]) 
+                   withObject:request];
+    } else {
+        // Add an operation to the callbackQueue with a completionBlock for the case of cancellation
+        NSInvocationOperation *operation = [[[NSInvocationOperation alloc] initWithTarget:self 
+                                                                                 selector:NSSelectorFromString([request.userInfo objectForKey:@"didFailSelector"]) 
+                                                                                   object:request] autorelease];
+        operation.completionBlock = ^{
+            NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+            if ([[request.userInfo objectForKey:@"operation"] isCancelled]) {
+                dispatch_async(dispatch_get_main_queue(), ^{
+                    [activityFacility endActivity:[request.userInfo objectForKey:@"activity"] 
+                                      withMessage:[request.userInfo objectForKey:@"stoppedActivityMessage"]];
+                });
+                [self syncOperationFinishedWithSuccess:NO];
+            }
+            [pool drain];
+        };
+        [(NSMutableDictionary *)request.userInfo setObject:operation forKey:@"operation"];
+        [callbackQueue addOperation:operation];
+    }
 }
 
 - (void)listRequestFinished:(ASIPithosContainerRequest *)containerRequest {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    NSOperation *operation = [containerRequest.userInfo objectForKey:@"operation"];
     NSLog(@"Sync::list request finished: %@", containerRequest.url);
-    if ((containerRequest.responseStatusCode == 200) || (containerRequest.responseStatusCode == 304)) {
+    if (operation.isCancelled) {
+        [self listRequestFailed:containerRequest];
+    } else if ((containerRequest.responseStatusCode == 200) || (containerRequest.responseStatusCode == 304)) {
         if (containerRequest.responseStatusCode == 200) {
             NSArray *someObjects = [containerRequest objects];
             if (objects == nil) {
@@ -1012,13 +1133,20 @@
                 newContainerRequest.delegate = self;
                 newContainerRequest.didFinishSelector = @selector(performRequestFinishedDelegateInBackground:);
                 newContainerRequest.didFailSelector = @selector(performRequestFailedDelegateInBackground:);
-                newContainerRequest.userInfo = newContainerRequest.userInfo;
+                newContainerRequest.userInfo = containerRequest.userInfo;
                 [(NSMutableDictionary *)newContainerRequest.userInfo setObject:[NSNumber numberWithUnsignedInteger:10] forKey:@"retries"];
                 [networkQueue addOperation:[PithosUtilities prepareRequest:newContainerRequest priority:[[newContainerRequest.userInfo objectForKey:@"priority"] integerValue]]];
                 [pool drain];
                 return;
             }
         }
+        
+        if (operation.isCancelled) {
+            [self listRequestFailed:containerRequest];
+            [pool drain];
+            return;
+        }
+
         dispatch_async(dispatch_get_main_queue(), ^{
             [activityFacility endActivity:[containerRequest.userInfo objectForKey:@"activity"] 
                               withMessage:[containerRequest.userInfo objectForKey:@"finishedActivityMessage"]];
@@ -1031,19 +1159,33 @@
                 [PithosUtilities fileActionFailedAlertWithTitle:@"Directory Contents Error" 
                                                         message:[NSString stringWithFormat:@"Cannot get contents of directory at '%@'", containerDirectoryPath] 
                                                           error:error];
-                [activityFacility startAndEndActivityWithType:PithosActivityOther message:@"Sync: Failed to read contents of sync directory"];
+                [activityFacility startAndEndActivityWithType:PithosActivityOther 
+                                                      message:@"Sync: Failed to read contents of sync directory" 
+                                                pithosAccount:pithosAccount];
             });
-            @synchronized(self) {
-                // Since the local listing failed, the operation finished and the sync cycle is completeted unsuccessfully
-                syncOperationCount = 0;
-                if (newSyncRequested)
-                    [self sync];
-            }
+            // Since the local listing failed, the operation finished and the sync cycle is completeted unsuccessfully
+            [self syncOperationFinishedWithSuccess:NO];
+            [pool drain];
+            return;
+        }
+        
+        if (operation.isCancelled) {
+            operation.completionBlock = nil;
+            [self syncOperationFinishedWithSuccess:NO];
             [pool drain];
             return;
         }
+
         self.currentLocalObjectStates = [NSMutableDictionary dictionaryWithCapacity:[subPaths count]];
         for (NSString *objectName in subPaths) {
+            if (operation.isCancelled) {
+                operation.completionBlock = nil;
+                [self saveLocalState];
+                [self syncOperationFinishedWithSuccess:NO];
+                [pool drain];
+                return;
+            }
+
             PithosLocalObjectState *storedLocalObjectState = [storedLocalObjectStates objectForKey:objectName];
             NSString *filePath = [containerDirectoryPath stringByAppendingPathComponent:objectName];
             if (!storedLocalObjectState || [storedLocalObjectState isModified]) {
@@ -1062,12 +1204,42 @@
         }
         [self saveLocalState];
 
+        if (operation.isCancelled) {
+            operation.completionBlock = nil;
+            [self syncOperationFinishedWithSuccess:NO];
+            [pool drain];
+            return;
+        }
+
         for (NSString *objectName in remoteObjects) {
+            if (operation.isCancelled) {
+                operation.completionBlock = nil;
+                [self saveLocalState];
+                [self syncOperationFinishedWithSuccess:NO];
+                [pool drain];
+                return;
+            }
+
             if (![storedLocalObjectStates objectForKey:objectName])
                 [storedLocalObjectStates setObject:[PithosLocalObjectState localObjectState] forKey:objectName];
         }
+        [self saveLocalState];
+
+        if (operation.isCancelled) {
+            operation.completionBlock = nil;
+            [self syncOperationFinishedWithSuccess:NO];
+            [pool drain];
+            return;
+        }
 
         for (NSString *objectName in [[storedLocalObjectStates allKeys] sortedArrayUsingSelector:@selector(compare:)]) {
+            if (operation.isCancelled) {
+                operation.completionBlock = nil;
+                [self syncOperationFinishedWithSuccess:NO];
+                [pool drain];
+                return;
+            }
+
             NSString *filePath = [containerDirectoryPath stringByAppendingPathComponent:objectName];
             if ([objectName hasSuffix:@"/"])
                 filePath = [filePath stringByAppendingString:@":"];
@@ -1179,45 +1351,30 @@
                 }
             }
         }
-        @synchronized(self) {
-            [self decreaseSyncOperationCount];
-            if (newSyncRequested && !syncOperationCount)
-                [self sync];
-        }
+        [self syncOperationFinishedWithSuccess:YES];
     } else {
-        NSUInteger retries = [[containerRequest.userInfo objectForKey:@"retries"] unsignedIntegerValue];
-        if (retries > 0) {
-            ASIPithosContainerRequest *newContainerRequest = (ASIPithosContainerRequest *)[[PithosUtilities copyRequest:containerRequest] autorelease];
-            [(NSMutableDictionary *)(newContainerRequest.userInfo)setObject:[NSNumber numberWithUnsignedInteger:(--retries)] forKey:@"retries"];
-            [networkQueue addOperation:[PithosUtilities prepareRequest:newContainerRequest priority:[[newContainerRequest.userInfo objectForKey:@"priority"] integerValue]]];
-        } else {
-            dispatch_async(dispatch_get_main_queue(), ^{
-                [activityFacility endActivity:[containerRequest.userInfo objectForKey:@"activity"] 
-                                  withMessage:[containerRequest.userInfo objectForKey:@"failedActivityMessage"]];
-            });
-            @synchronized(self) {
-                // Since the server listing failed in all retries, the operation finished and the sync cycle is completeted unsuccesfully
-                syncOperationCount = 0;
-                if (newSyncRequested)
-                    [self sync];
-            }
-        }
+        [self listRequestFailed:containerRequest];
     }
     [pool drain];
 }
 
 - (void)listRequestFailed:(ASIPithosContainerRequest *)containerRequest {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
-    if ([containerRequest isCancelled]) {
+    NSOperation *operation = [containerRequest.userInfo objectForKey:@"operation"];
+    if (operation.isCancelled) {
+        [objects release];
+        objects = nil;
+        [pool drain];
+        return;        
+    }
+    if (containerRequest.isCancelled) {
         dispatch_async(dispatch_get_main_queue(), ^{
             [activityFacility endActivity:[containerRequest.userInfo objectForKey:@"activity"] 
                               withMessage:[containerRequest.userInfo objectForKey:@"stoppedActivityMessage"]];
         });
         [objects release];
         objects = nil;
-        @synchronized(self) {
-            syncOperationCount = 0;
-        }
+        [self syncOperationFinishedWithSuccess:NO];
         [pool drain];
         return;
     }
@@ -1234,20 +1391,19 @@
         });
         [objects release];
         objects = nil;
-        @synchronized(self) {
-            // Since the server listing failed in all retries, the operation finished and the sync cycle is completeted unsuccesfully
-            syncOperationCount = 0;
-            if (newSyncRequested)
-                [self sync];
-        }
+        // Since the server listing failed in all retries, the operation finished and the sync cycle is completeted unsuccesfully
+        [self syncOperationFinishedWithSuccess:NO];
     }
     [pool drain];
 }
 
 - (void)downloadObjectBlockFinished:(ASIPithosObjectRequest *)objectRequest {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    NSOperation *operation = [objectRequest.userInfo objectForKey:@"operation"];
     NSLog(@"Sync::download object block finished: %@", objectRequest.url);
-    if (objectRequest.responseStatusCode == 206) {
+    if (operation.isCancelled) {
+        [self requestFailed:objectRequest];
+    } else if (objectRequest.responseStatusCode == 206) {
         ASIPithosObject *object = [objectRequest.userInfo objectForKey:@"pithosObject"];
         NSFileManager *fileManager = [NSFileManager defaultManager];
         NSError *error;
@@ -1259,12 +1415,7 @@
                 [activityFacility endActivity:activity 
                                   withMessage:[objectRequest.userInfo objectForKey:@"failedActivityMessage"]];
             });
-            @synchronized(self) {
-                syncIncomplete = YES;
-                [self decreaseSyncOperationCount];
-                if (newSyncRequested && !syncOperationCount)
-                    [self sync];
-            }
+            [self syncOperationFinishedWithSuccess:NO];
             [pool drain];
             return;
         }
@@ -1286,12 +1437,7 @@
                     [activityFacility endActivity:activity 
                                       withMessage:[objectRequest.userInfo objectForKey:@"failedActivityMessage"]];
                 });
-                @synchronized(self) {
-                    syncIncomplete = YES;
-                    [self decreaseSyncOperationCount];
-                    if (newSyncRequested && !syncOperationCount)
-                        [self sync];
-                }
+                [self syncOperationFinishedWithSuccess:NO];
                 [pool drain];
                 return;
             }
@@ -1317,12 +1463,7 @@
                     [activityFacility endActivity:activity 
                                       withMessage:[objectRequest.userInfo objectForKey:@"failedActivityMessage"]];
                 });
-                @synchronized(self) {
-                    syncIncomplete = YES;
-                    [self decreaseSyncOperationCount];
-                    if (newSyncRequested && !syncOperationCount)
-                        [self sync];
-                }
+                [self syncOperationFinishedWithSuccess:NO];
                 [pool drain];
                 return;
             } else if (![fileManager fileExistsAtPath:dirPath]) {
@@ -1339,12 +1480,7 @@
                         [activityFacility endActivity:[objectRequest.userInfo objectForKey:@"activity"] 
                                           withMessage:[objectRequest.userInfo objectForKey:@"failedActivityMessage"]];
                     });
-                    @synchronized(self) {
-                        syncIncomplete = YES;
-                        [self decreaseSyncOperationCount];
-                        if (newSyncRequested && !syncOperationCount)
-                            [self sync];
-                    }
+                    [self syncOperationFinishedWithSuccess:NO];
                     [pool drain];
                     return;
                 }
@@ -1360,12 +1496,7 @@
                     [activityFacility endActivity:activity 
                                       withMessage:[objectRequest.userInfo objectForKey:@"failedActivityMessage"]];
                 });
-                @synchronized(self) {
-                    syncIncomplete = YES;
-                    [self decreaseSyncOperationCount];
-                    if (newSyncRequested && !syncOperationCount)
-                        [self sync];
-                }
+                [self syncOperationFinishedWithSuccess:NO];
                 [pool drain];
                 return;
             }
@@ -1380,28 +1511,12 @@
             storedState.hash = object.objectHash;
             storedState.tmpFilePath = nil;
             [self saveLocalState];
-            
-            @synchronized(self) {
-                [self decreaseSyncOperationCount];
-                if (newSyncRequested && !syncOperationCount)
-                    [self sync];
-            }
+            [self syncOperationFinishedWithSuccess:YES];
             [pool drain];
             return;
         } else {
-            if (newSyncRequested) {
-                dispatch_async(dispatch_get_main_queue(), ^{
-                    [activityFacility endActivity:[objectRequest.userInfo objectForKey:@"activity"] 
-                                      withMessage:[objectRequest.userInfo objectForKey:@"stoppedActivityMessage"]];
-                });
-                @synchronized(self) {
-                    syncIncomplete = YES;
-                    [self decreaseSyncOperationCount];
-                    if (!syncOperationCount)
-                        [self sync];
-                }
-                [pool drain];
-                return;
+            if (newSyncRequested || syncLate || operation.isCancelled) {
+                [self requestFailed:objectRequest];
             } else {
                 __block ASIPithosObjectRequest *newObjectRequest = [PithosUtilities objectBlockDataRequestWithPithos:pithos 
                                                                                                        containerName:containerName 
@@ -1431,12 +1546,7 @@
             [activityFacility endActivity:[objectRequest.userInfo objectForKey:@"activity"] 
                               withMessage:[objectRequest.userInfo objectForKey:@"stoppedActivityMessage"]];
         });
-        @synchronized(self) {
-            syncIncomplete = YES;
-            [self decreaseSyncOperationCount];
-            if (newSyncRequested && !syncOperationCount)
-                [self sync];
-        }
+        [self syncOperationFinishedWithSuccess:NO];
     } else {
         [self requestFailed:objectRequest];
     }
@@ -1445,21 +1555,13 @@
 
 - (void)downloadObjectHashMapFinished:(ASIPithosObjectRequest *)objectRequest {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    NSOperation *operation = [objectRequest.userInfo objectForKey:@"operation"];
     NSLog(@"Sync::download object hashmap finished: %@", objectRequest.url);
-    if (objectRequest.responseStatusCode == 200) {
-        if (newSyncRequested) {
-            dispatch_async(dispatch_get_main_queue(), ^{
-                [activityFacility endActivity:[objectRequest.userInfo objectForKey:@"activity"] 
-                                  withMessage:[objectRequest.userInfo objectForKey:@"stoppedActivityMessage"]];
-            });
-            @synchronized(self) {
-                syncIncomplete = YES;
-                [self decreaseSyncOperationCount];
-                if (!syncOperationCount)
-                    [self sync];
-            }
-            [pool drain];
-            return;
+    if (operation.isCancelled) {
+        [self requestFailed:objectRequest];
+    } else if (objectRequest.responseStatusCode == 200) {
+        if (newSyncRequested || syncLate || operation.isCancelled) {
+            [self requestFailed:objectRequest];
         } else {
             ASIPithosObject *object = [objectRequest.userInfo objectForKey:@"pithosObject"];
             PithosLocalObjectState *storedState = [storedLocalObjectStates objectForKey:object.name];
@@ -1511,8 +1613,11 @@
 
 - (void)uploadDirectoryObjectFinished:(ASIPithosObjectRequest *)objectRequest {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    NSOperation *operation = [objectRequest.userInfo objectForKey:@"operation"];
     NSLog(@"Sync::upload directory object finished: %@", objectRequest.url);
-    if (objectRequest.responseStatusCode == 201) {
+    if (operation.isCancelled) {
+        [self requestFailed:objectRequest];
+    } else if (objectRequest.responseStatusCode == 201) {
         PithosLocalObjectState *storedState = [storedLocalObjectStates objectForKey:[[objectRequest.userInfo objectForKey:@"pithosObject"] name]];
         storedState.isDirectory = YES;
         [self saveLocalState];
@@ -1520,11 +1625,7 @@
             [activityFacility endActivity:[objectRequest.userInfo objectForKey:@"activity"] 
                               withMessage:[objectRequest.userInfo objectForKey:@"finishedActivityMessage"]];
         });
-        @synchronized(self) {
-            [self decreaseSyncOperationCount];
-            if (newSyncRequested && !syncOperationCount)
-                [self sync];
-        }
+        [self syncOperationFinishedWithSuccess:YES];
     } else {
         [self requestFailed:objectRequest];
     }
@@ -1533,19 +1634,18 @@
 
 - (void)moveObjectToTrashFinished:(ASIPithosObjectRequest *)objectRequest {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    NSOperation *operation = [objectRequest.userInfo objectForKey:@"operation"];
     NSLog(@"Sync::move object to trash finished: %@", objectRequest.url);
-    if (objectRequest.responseStatusCode == 201) {
+    if (operation.isCancelled) {
+        [self requestFailed:objectRequest];
+    } else if (objectRequest.responseStatusCode == 201) {
         [storedLocalObjectStates removeObjectForKey:[[objectRequest.userInfo objectForKey:@"pithosObject"] name]];
         [self saveLocalState];
         dispatch_async(dispatch_get_main_queue(), ^{
             [activityFacility endActivity:[objectRequest.userInfo objectForKey:@"activity"] 
                               withMessage:[objectRequest.userInfo objectForKey:@"finishedActivityMessage"]];
         });
-        @synchronized(self) {
-            [self decreaseSyncOperationCount];
-            if (newSyncRequested && !syncOperationCount)
-                [self sync];
-        }
+        [self syncOperationFinishedWithSuccess:YES];
     } else {
         [self requestFailed:objectRequest];
     }
@@ -1554,13 +1654,16 @@
 
 - (void)uploadObjectUsingHashMapFinished:(ASIPithosObjectRequest *)objectRequest {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    NSOperation *operation = [objectRequest.userInfo objectForKey:@"operation"];
     NSLog(@"Sync::upload using hashmap finished: %@", objectRequest.url);
     ASIPithosObject *object = [objectRequest.userInfo objectForKey:@"pithosObject"];
     PithosLocalObjectState *storedState = [storedLocalObjectStates objectForKey:object.name];
     PithosActivity *activity = [objectRequest.userInfo objectForKey:@"activity"];
     NSUInteger totalBytes = activity.totalBytes;
     NSUInteger currentBytes = activity.currentBytes;
-    if (objectRequest.responseStatusCode == 201) {
+    if (operation.isCancelled) {
+        [self requestFailed:objectRequest];
+    } else if (objectRequest.responseStatusCode == 201) {
         NSLog(@"Sync::object created: %@", objectRequest.url);
         storedState.hash = [objectRequest objectHash];
         [self saveLocalState];
@@ -1570,35 +1673,18 @@
                                totalBytes:totalBytes 
                              currentBytes:totalBytes];
         });
-        @synchronized(self) {
-            [self decreaseSyncOperationCount];
-            if (newSyncRequested && !syncOperationCount)
-                [self sync];
-        }
+        [self syncOperationFinishedWithSuccess:YES];
     } else if (objectRequest.responseStatusCode == 409) {
-        if (newSyncRequested) {
-            dispatch_async(dispatch_get_main_queue(), ^{
-                [activityFacility endActivity:activity 
-                                  withMessage:[objectRequest.userInfo objectForKey:@"stoppedActivityMessage"]];
-            });
-            @synchronized(self) {
-                syncIncomplete = YES;
-                [self decreaseSyncOperationCount];
-                if (!syncOperationCount)
-                    [self sync];
-            }
-            [pool drain];
-            return;
+        if (newSyncRequested || syncLate || operation.isCancelled) {
+            [self requestFailed:objectRequest];
         } else {
             NSUInteger iteration = [[objectRequest.userInfo objectForKey:@"iteration"] unsignedIntegerValue];
             if (iteration == 0) {
                 NSLog(@"Sync::upload iteration limit reached: %@", objectRequest.url);
                 dispatch_async(dispatch_get_main_queue(), ^{
-                    [activityFacility endActivity:activity 
-                                      withMessage:[objectRequest.userInfo objectForKey:@"stoppedActivityMessage"]];
+                    [activityFacility endActivity:activity withMessage:[objectRequest.userInfo objectForKey:@"stoppedActivityMessage"]];
                 });
-                syncIncomplete = YES;
-                [self decreaseSyncOperationCount];
+                [self syncOperationFinishedWithSuccess:NO];
                 [pool drain];
                 return;
             }
@@ -1645,14 +1731,19 @@
 
 - (void)uploadMissingBlockFinished:(ASIPithosContainerRequest *)containerRequest {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    NSOperation *operation = [containerRequest.userInfo objectForKey:@"operation"];
     NSLog(@"Sync::upload of missing block finished: %@", containerRequest.url);
-    if (containerRequest.responseStatusCode == 202) {
+    if (operation.isCancelled) {
+        [self requestFailed:containerRequest];
+    } else if (containerRequest.responseStatusCode == 202) {
         ASIPithosObject *object = [containerRequest.userInfo objectForKey:@"pithosObject"];
         PithosActivity *activity = [containerRequest.userInfo objectForKey:@"activity"];
         NSIndexSet *missingBlocks = [containerRequest.userInfo objectForKey:@"missingBlocks"];
         NSUInteger missingBlockIndex = [[containerRequest.userInfo objectForKey:@"missingBlockIndex"] unsignedIntegerValue];
         missingBlockIndex = [missingBlocks indexGreaterThanIndex:missingBlockIndex];
-        if (missingBlockIndex == NSNotFound) {
+        if (operation.isCancelled) {
+            [self requestFailed:containerRequest];
+        } else if (missingBlockIndex == NSNotFound) {
             NSArray *hashes = [containerRequest.userInfo objectForKey:@"hashes"];
             ASIPithosObjectRequest *newObjectRequest = [PithosUtilities writeObjectDataRequestWithPithos:pithos 
                                                                                            containerName:containerName 
